﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;

using ProjectBoat_bae.Entities;
namespace ProjectBoat_bae.DrawningObjects
{
    public class DrawningMotorBoat : Drawningboat
    {

        public DrawningMotorBoat(int speed, double weight, Color bodyColor, Color
        additionalColor, bool body, bool wing, 
        int width, int height) : base(speed, weight, bodyColor, width, height, 110, 60)

        {
            if (EntityBoat != null)
            {
                EntityBoat = new EntityMotorBoat(speed, weight, bodyColor,
                additionalColor, body, wing);
                
            }
        }

        public override void DrawTransport(Graphics g)
        {
            if (EntityBoat is not EntityMotorBoat Boat)
            {
                return;
            }
            Pen pen = new(Color.Black);
            Brush additionalBrush = new SolidBrush(Boat.AdditionalColor);
            Brush br = new SolidBrush(EntityBoat.BodyColor);
            Brush brRed = new SolidBrush(EntityBoat.BodyColor);
            Brush brBlue = new SolidBrush(Color.LightBlue);

            if (Boat.Body)
            {
                //вёсла
                g.FillRectangle(brRed, _startPosX + 35, _startPosY - 5, 5, 65);
                g.FillRectangle(brRed, _startPosX + 28, _startPosY + 60, 12, 8);
                g.FillRectangle(brRed, _startPosX + 28, _startPosY - 5, 12, 8);
            }
            base.DrawTransport(g);
        }
    }
 }
