﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ProjectBoat_bae.DrawningObjects;
using ProjectBoat_bae.MovementStrategy;

namespace ProjectBoat_bae.Generics
{
    internal class BoatsGenericStorage
    {
        readonly Dictionary<string, BoatsGenericCollection<Drawningboat, DrawningObjectBoat>> _boatStorages;
        public List<string> Keys => _boatStorages.Keys.ToList();

        private readonly int _pictureWidth;
        private readonly int _pictureHeight;
        public BoatsGenericStorage(int pictureWidth, int pictureHeight)
        {
            _boatStorages = new Dictionary<string, BoatsGenericCollection<Drawningboat, DrawningObjectBoat>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }
        public void AddSet(string name)
        {
            if (_boatStorages.ContainsKey(name)) return;
            _boatStorages[name] = new BoatsGenericCollection<Drawningboat, DrawningObjectBoat>(_pictureWidth, _pictureHeight);
        }

        public void DelSet(string name)
        {
            if (!_boatStorages.ContainsKey(name)) return;
            _boatStorages.Remove(name);
        }

        public BoatsGenericCollection<Drawningboat, DrawningObjectBoat>?
            this[string ind]
        {
            get
            {
                if (_boatStorages.ContainsKey(ind)) return _boatStorages[ind];
                return null;
            }
        }
    }
}
