﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;

using ProjectBoat_bae;
using ProjectBoat_bae.Entities;
using ProjectBoat_bae.DrawningObjects;
namespace ProjectBoat_bae.MovementStrategy
{
    // Реализация интерфейса для работы с объектом DrawningBoat!
    public class DrawningObjectBoat : IMoveableObject
    {
        private readonly Drawningboat? _drawingBoat = null;
  
        public DrawningObjectBoat(Drawningboat drawingBoat)
        {
            _drawingBoat = drawingBoat;
        }
        //!
        public ObjectParameters? GetObjectPosition
        {
            get
            {
                if (_drawingBoat == null || _drawingBoat.EntityBoat == null)
                {
                    return null;
                }
                return new ObjectParameters(_drawingBoat.GetPosX,
                _drawingBoat.GetPosY, _drawingBoat.GetWidth, _drawingBoat.GetHeight);
            }
        }
        public int GetStep => (int)(_drawingBoat?.EntityBoat?.Step ?? 0);
        public bool CheckCanMove(DiretionType direction) => _drawingBoat?.CanMove(direction) ?? false;
        public void MoveObject(DiretionType direction) => _drawingBoat?.MoveTransport(direction);
    }
}
